  module io_m
  use particle_m
  use rules_m

  contains

  ! ------------------------------------------------------------------
  ! WRITE STATE TO A FILE
  subroutine write_state( fname )
  implicit none
  character (len=*), intent(in) :: fname

  character*10 simstepstr
  integer ofile
  integer i, j

  ofile = 3
  write(simstepstr,'(1i4.4)') simstep
  open(unit=ofile,file=trim(adjustl(fname))//trim(adjustl(simstepstr))//'.vtp',form='formatted')

  write(ofile,'(A)') '<?xml version="1.0"?>'
  write(ofile,'(A)') '<VTKFile type="PolyData" version="0.1" byte_order="LittleEndian" compressor="vtkZLibDataCompressor">'
  write(ofile,'(A)') '  <PolyData>'
  write(ofile,'(A,1I5,A,1I5,A,1I5,A)') &
                     '    <Piece NumberOfPoints="',num_particles,'" NumberOfVerts="',num_particles,&
                          '" NumberOfLines="0" NumberOfStrips="0" NumberOfPolys="',num_tri_springs,'">'

  write(ofile,'(A)') '      <Points>'
  write(ofile,'(A)') '        <DataArray type="Float32" format="ascii" NumberOfComponents="3" Name="pxyz">'
  write(ofile,*)               ( ( pxyz(i,j), j = 1,3 ), i = 1,num_particles )
  write(ofile,'(A)') '        </DataArray>'
  write(ofile,'(A)') '      </Points>'

  write(ofile,'(A)') '      <Verts>'
  write(ofile,'(A)') '        <DataArray type="Int64" format="ascii" Name="connectivity">'
  do i = 1, num_particles
    write(ofile,*)              1,i - 1
  enddo
  write(ofile,'(A)') '        </DataArray>'
  write(ofile,'(A)') '        <DataArray type="Int64" format="ascii" Name="offsets">'
  do i = 1, num_particles
    write(ofile,*)              2*i
  enddo
  write(ofile,'(A)') '        </DataArray>'
  write(ofile,'(A)') '      </Verts>'

  write(ofile,'(A)') '      <Polys>'
  write(ofile,'(A)') '        <DataArray type="Int64" format="ascii" Name="connectivity">'
  do i = 1, num_particles
    write(ofile,*)              ( its(i,j) - 1, j = 1,3 )
  enddo
  write(ofile,'(A)') '        </DataArray>'
  write(ofile,'(A)') '        <DataArray type="Int64" format="ascii" Name="offsets">'
  do i = 1, num_particles
    write(ofile,*)              3*i
  enddo
  write(ofile,'(A)') '        </DataArray>'
  write(ofile,'(A)') '      </Polys>'

  write(ofile,'(A)') '      <PointData Scalars="mass" Vectors="pmom">'
  write(ofile,'(A)') '        <DataArray type="Float32" format="ascii" NumberOfComponents="3" Name="pmom">'
  write(ofile,*)               ( ( pmom(i,j), j = 1,3 ), i = 1,num_particles )
  write(ofile,'(A)') '        </DataArray>'
  write(ofile,'(A)') '        <DataArray type="Float32" format="ascii" NumberOfComponents="3" Name="pfrc">'
  write(ofile,*)               ( ( pfrc(i,j), j = 1,3 ), i = 1,num_particles )
  write(ofile,'(A)') '        </DataArray>'
  write(ofile,'(A)') '        <DataArray type="Float32" format="ascii" NumberOfComponents="1" Name="mass">'
  write(ofile,*)               ( mass(i), i = 1,num_particles )
  write(ofile,'(A)') '        </DataArray>'
  write(ofile,'(A)') '      </PointData>'

  write(ofile,'(A)') '    </Piece>'
  write(ofile,'(A)') '  </PolyData>'
  write(ofile,'(A)') '</VTKFile>'

  close(ofile)
  end subroutine write_state
  ! ------------------------------------------------------------------

  end module io_m
