  ! ------------------------------------------------------------------
  ! PARALLEL MACHINE DESCRIPTION
  ! ------------------------------------------------------------------
  module parallel_m
  include 'mpif.h'

  ! ------------------------------------------------------------------
  integer local_id
  integer num_proc
  integer global_comm
  ! ------------------------------------------------------------------

  contains

  ! ------------------------------------------------------------------
  ! PREPARE MODULE FOR PARALLEL PROCESSING
  subroutine initialize()

  implicit none
  integer ierr

  call MPI_Init( ierr )
  call MPI_Comm_rank( MPI_COMM_WORLD, local_id, ierr )
  call MPI_Comm_size( MPI_COMM_WORLD, num_proc, ierr )
  global_comm = MPI_COMM_WORLD
1 format( 'Running with ', i3.1, ' processes.' )
  if ( local_id .eq. 0 ) write (*,1) num_proc

  end subroutine initialize
  ! ------------------------------------------------------------------

  ! ------------------------------------------------------------------
  ! SHUT DOWN PARALLEL PROCESSING
  subroutine finalize()

  implicit none
  integer ierr

  call MPI_Finalize( ierr )

  end subroutine finalize
  ! ------------------------------------------------------------------

  end module parallel_m
